﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using System.Diagnostics;

namespace SelectedTipeName
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("B14B5266-494B-4A16-95A9-E4A9F8A2C60D"), ProgId("SelectedTipeName-cs.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private ADXExcelAppEvents adxExcelEvents;
        private ADXCommandBar adxCommandBarTest;
        private ADXCommandBarButton adxCommandBarButton1;
        private ADXRibbonTab adxRibbonTabTest;
        private ADXRibbonGroup adxRibbonGroup1;
        private ADXRibbonButton adxRibbonButton1;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxExcelEvents = new AddinExpress.MSO.ADXExcelAppEvents(this.components);
            this.adxCommandBarTest = new AddinExpress.MSO.ADXCommandBar(this.components);
            this.adxCommandBarButton1 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.adxRibbonTabTest = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxRibbonGroup1 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.adxRibbonButton1 = new AddinExpress.MSO.ADXRibbonButton(this.components);
            // 
            // adxExcelEvents
            // 
            this.adxExcelEvents.CommandBarsUpdate += new System.EventHandler(this.adxExcelEvents_CommandBarsUpdate);
            // 
            // adxCommandBarTest
            // 
            this.adxCommandBarTest.CommandBarName = "Excel Selection Tools";
            this.adxCommandBarTest.CommandBarTag = "4b1c6d3b-91e1-4cc4-aced-46a8e561237b";
            this.adxCommandBarTest.Controls.Add(this.adxCommandBarButton1);
            this.adxCommandBarTest.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel;
            this.adxCommandBarTest.UpdateCounter = 11;
            // 
            // adxCommandBarButton1
            // 
            this.adxCommandBarButton1.Caption = "Get selected object type name";
            this.adxCommandBarButton1.ControlTag = "465f4dd7-8a59-43be-9f32-657cdd965e1a";
            this.adxCommandBarButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCommandBarButton1.UpdateCounter = 9;
            // 
            // adxRibbonTabTest
            // 
            this.adxRibbonTabTest.Caption = "Excel Selection";
            this.adxRibbonTabTest.Controls.Add(this.adxRibbonGroup1);
            this.adxRibbonTabTest.Id = "adxRibbonTab_c7b4969980b54187b2d3e096b626097e";
            this.adxRibbonTabTest.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // adxRibbonGroup1
            // 
            this.adxRibbonGroup1.Caption = "Selection Tools";
            this.adxRibbonGroup1.Controls.Add(this.adxRibbonButton1);
            this.adxRibbonGroup1.Id = "adxRibbonGroup_dcfb52350d1f4d389cb99521c15d8d47";
            this.adxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // adxRibbonButton1
            // 
            this.adxRibbonButton1.Caption = "Get selected object type name";
            this.adxRibbonButton1.Id = "adxRibbonButton_53639786a3ce433ebff9d9f65f2f614a";
            this.adxRibbonButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonButton1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // AddinModule
            // 
            this.AddinName = "SelectedTipeName-cs";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel;

        }
        #endregion
 
        #region Add-in Express automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance 
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Excel._Application ExcelApp
        {
            get
            {
                return (HostApplication as Excel._Application);
            }
        }

        private void adxExcelEvents_CommandBarsUpdate(object sender, EventArgs e)
        {
            GetSelectionTypeName();
        }

        private void GetSelectionTypeName()
        {
            object selection = ExcelApp.Selection;
            if (selection != null)
            {
                string typeName = ComHelper.GetTypeName(selection);
                Debug.Print(typeName);
            if (selection is Excel.Shape)
            {
                try
                {
                    Excel.Shape shape = selection as Excel.Shape;
                    if (shape != null)
                    {
                        //shape.
                    }
                }
                catch { }
            }            
                Marshal.ReleaseComObject(selection);
            }

        }
    }
}

